// Thur Sep 20
// Game Demo Code

int count;
int startTime, endTime, targetDisplayTime,  targetStartTime, totalTargetTime, gameTime;
int gamePhase;
color targetColor;
float x, y, diam;

void setup( )
{
   size( 400, 400 );
   textSize( 24 );
   textAlign( CENTER );
   fill( 255 );
   count = 0;
   startTime = 0;
   endTime = 0;
   gamePhase = 0; 
   targetDisplayTime = 1000;  // milliseconds - change this to alter difficulty
   gameTime = 10000;   // milliseconds - change this to alter difficulty
}

void draw( )
{
  background( 0 );
  if ( gamePhase == 0 )
  {
    showInstructions( );
  }
  else if ( gamePhase == 1 )
  {
     playGame( );
  }
  else 
  {
    score( );
  }
}

void score( )
{
   fill( 255, 0, 0 );
   text("GAME OVER", width/2, 50 );
   text("You hit " + count + " targets.", width/2, 100 );
   if ( count < 3 )
   {
      text("Sad...", width/2, 150 );
   }
   else if ( count < 6 )
   {
      text("Not bad...", width/2, 150 );  
   }
   else 
   {
      text("Good...", width/2, 150 );   
   }
}

void checkTime( )
{
  fill( 255, 0, 0 );
  text( "Time Remaining: " + ( gameTime/1000 - ((millis( ) - startTime))/1000), width/2, 50 );
  if ( (millis( )-startTime) > gameTime )
  {
     gamePhase = 2;
  } 
}

void showScore( )
{
    fill( 255 );
    text( "Hits " + count, width/2, height*.9); 
}

void checkHit( )
{
     float d = dist( x, y, mouseX, mouseY );
     if ( d < diam/2)
     {
       count++;
       fill( 255,0, 0 );
       rect( 0, 0, width, height );
       targetStartTime = 0;
     } 
}

void drawLines( )
{
   stroke( 255, 255, 0 );
   line( 0,0, mouseX, mouseY);
   line( width, 0, mouseX, mouseY);
   line( 0, height, mouseX, mouseY);
   line( width, height, mouseX, mouseY ); 
}

void drawTarget( )
{
    totalTargetTime = millis( ) - targetStartTime;
    if ( totalTargetTime > targetDisplayTime )
    {
        targetColor = color( random( 255), random(255), random(255) );
        x = random( 50, width-50 );
        y = random( 50, width-50 );
        diam = random( 20, 70 );
        targetStartTime = millis( );
    }
    stroke( 0 );
    fill(targetColor) ;
    ellipse( x, y, diam, diam );
}

void playGame( )
{
   drawTarget( );
   drawLines( );
   checkHit( );
   showScore( );
   checkTime( );
}

void showInstructions( )
{
   text( "blah, blah, blah...", width/2, 50 ); 
   text("Press any key to play the game.", width/2, 100 );
}

void keyPressed( )
{
   if ( gamePhase == 0 )
   {
      gamePhase = 1;
      startTime = millis( );
   }
}




